<?php

namespace wpbuddy\rich_snippets;

if ( ! defined( 'ABSPATH' ) ) {
	exit;
} // Exit if accessed directly


/**
 * Class Admin_Post_Controller.
 *
 * Helps to manage things on the dit screen.
 *
 * @package wpbuddy\rich_snippets
 *
 * @since   2.28.0
 */
class Admin_Post_Controller {


	/**
	 * Magic method for setting upt the class.
	 *
	 * @since 2.28.0
	 */
	public function __construct() {

		$post_types = (array) get_option( 'wpb_rs/setting/post_types', array( 'post', 'page' ) );


		foreach ( $post_types as $post_type ) {
			$p = get_post_types( [ 'name' => $post_type ], 'objects' );
			$p = $p[ $post_type ];

			add_filter( sprintf( 'manage_edit-%s_sortable_columns', $post_type ), [ $this, 'sortable_columns' ] );
			add_filter( sprintf( 'manage_edit-%s_columns', $post_type ), [ $this, 'columns' ] );
			add_action(
				sprintf(
					'manage_%s_custom_column',
					str_replace( 'edit_', '', $p->cap->edit_posts )
				),
				[
					$this,
					'column'
				], 10, 2 );
		}

	}

	/**
	 *
	 * @param array $columns
	 *
	 * @return array
	 * @since 2.28.0
	 */
	public function sortable_columns( $columns ) {
		$columns['schema_count'] = 'schema_count';

		return $columns;
	}


	/**
	 *
	 * @param array $columns
	 *
	 * @return array
	 * @since 2.28.0
	 */
	public function columns( $columns ) {
		$columns['schema_count'] = __( 'Schema count', 'rich-snippets-schema' );

		return $columns;
	}


	/**
	 *
	 * @param string $colname
	 * @param int $post_id
	 *
	 * @return array
	 * @since 2.28.0
	 */
	public function column( $colname, $post_id ) {
		if ( 'schema_count' === $colname ) {
			echo count( Snippets_Model::get_snippets( $post_id ) );
		}
	}
}
